#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################


from Products.Archetypes.public import Schema
from Products.ATContentTypes.types.schemata import ATFolderSchema
from Products.ATContentTypes.types.ATFolder import ATFolder
from Products.ATContentTypes.types.ATContentType import updateActions

from Products.Archetypes.public import registerType

from Products.CMFDocMgt.config import *

from Products.Archetypes.public import DateTimeField, StringField
from Products.Archetypes.public import CalendarWidget, StringWidget


from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import getToolByName

from AccessControl import getSecurityManager, SpecialUsers
from Acquisition import aq_base, aq_parent, aq_chain

from OFS.ObjectManager import ObjectManager

import string


#############################################################################
##                             Setting                                     ##
#############################################################################

schema = ATFolderSchema +  Schema((
    StringField('id',
                 required=1,
                ),
    StringField('title',
                required=1,
                ),
    StringField('contact',
                required=1,
                widget=StringWidget(label_msgid='label_contact',i18n_domain='CMFDocMgt',description=' ',),
                ),
    DateTimeField('deadline',
                widget=CalendarWidget(label_msgid='label_deadline',i18n_domain='CMFDocMgt',description=' ',),
                ),
    StringField('email',
                validator='validate_email',
                widget=StringWidget(label_msgid='label_email',i18n_domain='CMFDocMgt',description=' ',),
                ),
    ))


class DocMgtFolder(ATFolder):
    """
        DocMgtFolder is folderish object for Files
    """
    
    schema         =  ATFolderSchema

    content_icon   = 'folder_icon.gif'
    meta_type      = 'DocMgtFolder'
    archetype_name = 'DocMgtFolder'
    immediate_view = 'docmgtfolder_view'
    default_view   = 'docmgtfolder_view'
    suppl_views    = ()
    newTypeFor     = ()
    typeDescription= ''
    typeDescMsgId  = ''
    assocMimetypes = ()
    assocFileExt   = ()

    
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "Folder"
    
    global_allow = 0
    
    allowed_content_types=('DocMgtFolder', 'DocMgtFile')
    
    filter_content_types = 1
    security = ClassSecurityInfo()

    actions = updateActions(ATFolder,
        ({ 'id'            : 'view'
            , 'name'          : 'View'
            , 'action'        : 'string:docmgtfolder_view'
            , 'permissions'   : (CMFCorePermissions.View, )
            }
          #, { 'id'            : 'edit'
          #  , 'name'          : 'Edit'
          #  , 'action'        : 'string:${folder_url}/docmgtfolder_edit_form'
          #  , 'permissions'   : (CMFCorePermissions.ModifyPortalContent, )
          #  }
          , { 'id'            : 'myfiles'
            , 'name'          : 'My Files'
            , 'action'        : 'string:${folder_url}/myfiles'
            , 'permissions'   : (CMFCorePermissions.View,)
            , 'visible':1
            , 'category'	  : 'object'
            },    
        )
    )
          
    
    security.declareProtected(CMFCorePermissions.View, 'getIcon')
    def getIcon(self, relative_to_portal=0):
        #request = self.REQUEST
        #path = self.absolute_url('relative')
        #
        #if self.getFoldericon():
        #
        #    #icon = path + '/icon'
        #    
        #    icon =  'icon'
        #    if relative_to_portal:
        #        return icon
        #    else:
        #        utool = getToolByName( self, 'portal_url' )
        #        # Relative to REQUEST['BASEPATH1']
        #        res = utool(relative=1) + '/' + icon
        #        while res[:1] == '/':
        #            res = res[1:]
        #        return res
        #    
        #else:
        return 'folder_icon.gif'
        

    #security.declarePrivate( '_verifyActionPermissions' )
    #def _verifyActionPermissions( self, action ):
    #    pp = action.get( 'permissions', () )
    #    if not pp:
    #        return 1
    #    for p in pp:
    #        if _checkPermission( p, self ):
    #            return 1
    #    return 0

    #security.declareProtected( DocMgtFolderPermissions.ChangeFolder, 'edit' )
    #def edit( self, title=None, description=None, author=None, email=None, deadline='2049/12/31' ):
    ##def edit( self, title=None, description=None, author=None, email=None, docstatus=None, deadline='2049/12/31' ):
    #    self.setTitle(title)
    #    self.setDescription(description)
    #    self.author = author
    #    self.email = email
    #    #if docstatus <> None:
    #    #    self.docstatus = docstatus
    #    self.deadline = deadline


    def findparent(object):
        """ find the direct parent """
    
        for parent in aq_chain(object):
            if parent is object:
                continue
            if parent == object:
                continue
            if isinstance(parent, ObjectManager):
                return parent
        return None    


    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative').replace('%20',' '),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )


    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()

    #############################################################################
    ##                       HTTP (and presumably FTP?) Request                ##
    #############################################################################

    def PUT_factory( self, name, typ, body ):
        """
            Dispatcher for PUT requests to non-existent IDs.  Returns
            an object of the appropriate type (or None, if we don't
            know what to do).
        """
        
        #LOG('CMFDocMgt', INFO, 'FTP uploading file in %s, new file is %s ' % (self.getId(), name))
        
        registry = getToolByName( self, 'content_type_registry' )
        if registry is None:
            return None

        typeObjectName = registry.findTypeName( name, typ, body )
        if typeObjectName is None:
            return None
        #bnHasDocAlready = 0
        if typeObjectName in ['File', 'Image', 'Document']:
            typeObjectName = 'DocMgtFile'
            #bnHasObjAlready = hasattr(self, name)
        
        
        
        #registry = getToolByName( self, 'content_type_registry' )
        #portal_membership = getToolByName( self, 'portal_membership' )
        #contact = portal_membership.getAuthenticatedMember()    
        
        
        self.invokeFactory( typeObjectName, name )
        self=getattr(folder, id, None)
        
        #self.insertProperties(author)        
        #log = 'New file content uploaded via FTP'
        
        # "refill" the created file content
        #self[name].edit(file=body, content_type=typ, norev=1)
        self[name].edit(file=body, norev=1)
        
        #obj = self[name]
        
        #LOG('CMFDocMgt', INFO, 'Created %s, id is %s ' % (typeObjectName, name))
        
        # XXX: this is butt-ugly.
        obj = aq_base( self._getOb( name ) )
        
        #if bnHasDocAlready:
        #    log = 'New file content uploaded via FTP'
        #    self._getOb( name ).updateRev(log)
        
        self._delObject( name )
        
            
        #LOG('CMFDocMgt', INFO, 'File uploaded successfully after delete')
        
        return obj
        
    #def manage_afterAdd(self, item, container):
    #    # print "afterAdd %s %s"%(str(item), str(container))
    #    parent = self.aq_parent
    #    while hasattr(parent, 'aq_parent'):
    #        if hasattr(parent.aq_explicit, 'getIs_allow_nested'):
    #            allow_nested= parent.aq_explicit.getIs_allow_nested()
    #            if not allow_nested:
    #                raise CMFDocMgtNestedException, \
    #                  "Cannot add a CMFDocMgt inside this non-nestable CMFDocMgt"
    #        parent = parent.aq_parent
    #        
    #    # maybe we can check_over_size and check_over_count here
    #    
    #    ATFolder.manage_afterAdd(self, item, container)
          


registerType(DocMgtFolder)
