#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################



from Products.Archetypes.public import Schema
from Products.ATContentTypes.types.schemata import ATFolderSchema
from Products.ATContentTypes.types.ATFolder import ATFolder
from Products.ATContentTypes.types.ATContentType import updateActions

from Products.Archetypes.public import registerType

from Products.CMFDocMgt.config import *


from Products.Archetypes.public import DateTimeField, StringField
from Products.Archetypes.public import CalendarWidget, StringWidget

from Acquisition import aq_inner, aq_base, aq_chain

from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import getToolByName
from OFS.ObjectManager import ObjectManager

from AccessControl import getSecurityManager, SpecialUsers
from Products.RevisionManager.util import escape_string, unescape_string

import string
import os.path
import DateTime

#############################################################################
##                             Setting                                     ##
#############################################################################

schema = ATFolderSchema +  Schema((
    StringField('id',
                 required=1,
                ),
    StringField('title',
                required=1,
                ),
    StringField('contact',
                required=1,
                widget=StringWidget(label_msgid='label_contact',i18n_domain='CMFDocMgt',description=' ',),
                ),
    StringField('email',
                validator='validate_email',
                widget=StringWidget(label_msgid='label_email',i18n_domain='CMFDocMgt',description=' ',),
                ),
    ))


class DocMgtRoot(ATFolder):
    """
        DocMgtRoot is folderish object for DocMgt Folder
    """
    
    schema         =  ATFolderSchema
    content_icon   = 'folder_icon.gif'
    meta_type      = 'DocMgtRoot'
    archetype_name = 'DocMgtRoot'
    immediate_view = 'docmgtroot_view'
    default_view   = 'docmgtroot_view'
    suppl_views    = ()
    newTypeFor     = ()
    typeDescription= ''
    typeDescMsgId  = ''
    assocMimetypes = ()
    assocFileExt   = ()

    
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "Document Project"
    
    global_allow = 1
    
    allowed_content_types=('DocMgtFolder','DocMgtFile',)
    
    filter_content_types = 1
    

    actions = updateActions(ATFolder,
        ( { 'id'            : 'view'
            , 'name'          : 'View'
            , 'action'        : 'string:docmgtroot_view'
            , 'permissions'   : (CMFCorePermissions.View, )
            , 'visible':1
            }
          , { 'id'            : 'link_revisionmanager'
            , 'name'          : 'RevisionManager'
            , 'action'        : 'string:link_revisionmanager'
            , 'permissions'   : (CMFCorePermissions.ManageProperties,)
            , 'visible':1
            , 'category'	  : 'object'
            }
          , { 'id'            : 'myfiles'
            , 'name'          : 'My Files'
            , 'action'        : 'string:${folder_url}/myfiles'
            , 'permissions'   : (CMFCorePermissions.View,)
            , 'visible':1
            , 'category'	  : 'object'
            }
        )
    )
          
    
    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        ATFolder.manage_afterAdd(self,item, container)
        
        
    
    security.declareProtected(CMFCorePermissions.View, 'getIcon')
    def getIcon(self, relative_to_portal=0):
        return 'folder_icon.gif'
        

    #############################################################################
    ##                             RevisionManager                             ##
    #############################################################################

    def findparent(object):
        """ find the direct parent """
    
        for parent in aq_chain(object):
            if parent is object:
                continue
            if parent == object:
                continue
            if isinstance(parent, ObjectManager):
                return parent
        return None    
        
        
    ## Script (Python) "checkOverDue"
    ##parameters=self
    ##title=Check the overdue date
    #		0 if not overdue
    #		1 if overdue
    security.declarePublic('checkOverDue')
    def checkOverDue(self, item):
        sdate = DateTime.DateTime().strftime('%Y/%m/%d')
        if not hasattr(item, 'getDeadline'): return 0
        if item.getDeadline():
            return sdate > item.getDeadline().strftime('%Y/%m/%d')
            #return test(sdate > str(item.deadline),1,0)
        else:
            return 0
        
        
    security.declarePublic( 'getFileSizeStr' )
    def getFileSizeStr(self, bytes):
    
        try:
            
            """
            Format a number of bytes as bytes, K, or MB.
            """
            megs=bytes / 1048576.0
            if megs > 1:
                return "%.2f MB" % megs
            k=bytes / 1024.0
            if k > 1:
                return "%d K" % k
            return "%d bytes" % bytes
        except:
            return None

    security.declarePrivate('deserialize')
    def deserialize(self, serials):
        assert type(serials) is type('')
        properties = []
        lines = serials.split('\n')
        for line in lines:
            if line.startswith('#'):
                continue
            try:
                key, value = line.split('=')
            except ValueError:
                continue
            id, typ = key.split(':')
            id.strip()
            typ.strip()
            value = unescape_string(value)
            try:
                if type_converters.has_key(typ):
                    value = type_converters[typ](value)
                properties.append({
                    'id':    id,
                    'type':  typ,
                    'value': value
                    })
            except:
                continue
        return tuple(properties)


    security.declareProtected(CMFCorePermissions.ManageProperties, "soqrm_mapFSObjects")
    def soqrm_mapFSObjects(self, REQUEST, RESPONSE, items=[]):
        """
        Map file system files to objects.
        """
        failed = []
        for item in items:
            if item.get('add', 0):
                path = item['path']
                rt = self.soqaddFSFileObject(path, item['meta_type'])
                if rt:
                    failed.append(path)
        if failed:
            message = "Object creation failed for: %s" % ' '.join(failed)
            portal_status_message = message
        else:
            portal_status_message = 'Config+Action+Finished+Successfully'
        return REQUEST.RESPONSE.redirect(self.absolute_url().replace('%20',' ') + '/view?portal_status_message=' + portal_status_message)


    security.declareProtected(CMFCorePermissions.ManageProperties, 'soqaddFSFileObject')
    def soqaddFSFileObject(self, path, meta_type):
        segments = path.split("/")
        rm = self.RevisionManager
        contact = self.portal_membership.getAuthenticatedMember()
        # first make sure that the directory part of the path exists
        # if it doesn't, create as many folders as necessary
        folder = aq_inner(self) #aq_parent(aq_inner(self))
        for id in segments[:-1]:
            subfolder = getattr(folder, id, None)
            if subfolder is None:
                folder.invokeFactory(id=id, type_name='DocMgtFolder', title=id)
                subfolder = getattr(folder, id)
            folder = subfolder

        # now add the object
        # first the the appropriate factory
        id = segments[-1]
        abs_filename = rm.getAbsoluteFilePath(path)
        # read the file contents
        data = open(abs_filename, "rb").read()

        self.REQUEST.set('MappingRM', 1)
        if not rm._settings['save_properties']:
            try:
                #folder.invokeFactory(id=id, type_name='DocMgtFile')
                folder.invokeFactory( 'DocMgtFile', id)
                obj=getattr(folder, id, None)
                #obj.insertProperties(author)
                title = id
                obj.edit(title=title,
                         description='It is ' + title,
                         file=data,
                         contact=contact,
                         email='')
                #obj.edit(title=title,
                #         description='It is ' + title,
                #         file=data,
                #         author=author,
                #         email='')
            except:
                return 1
            
            #folder._setObject(id, obj)
            return 0

        basename = os.path.basename(abs_filename)
        dirname = os.path.dirname(abs_filename)
        prop_path = os.path.join(dirname, "." + basename + '.properties')

        properties = ()
        title = id
        props = {}
        # it could be that there is no properties file, so we
        # better check
        if os.path.isfile(prop_path):
            # read the properties file and deserialize the data
            fp = open(prop_path, "rb")
            serial = fp.read()
            fp.close()
            properties = self.deserialize(serial)

            for propdict in properties:
                if propdict['id'] == 'title':
                    title = propdict['value']
                else:
                    props[propdict['id']] = propdict['value']

        # create the object
        try:
            folder.invokeFactory( 'DocMgtFile', id)
            obj=getattr(folder, id, None)
            
            obj.edit(title=title, 
                     file=data,
                     **props)

        except:
            return 1

        # write properties if available and possible
        if properties:
            adapter = propertyAdapterRegistry.getAdapter(obj)
            if adapter is not None:
                obj_status = rm.getStatus(path)
                obj_status['have_props'] = 1
                if properties != adapter.getProperties(obj):
                    try:
                    
                        adapter.setProperties(obj, properties)
                    except:
                        return 1
        #obj.insertProperties(author)
        #folder._setObject(id, obj)
        return 0


    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative'),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )


    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()

    #############################################################################
    ##                       HTTP (and presumably FTP?) Request                ##
    #############################################################################

    def PUT_factory( self, name, typ, body ):
        """
            Dispatcher for PUT requests to non-existent IDs.  Returns
            an object of the appropriate type (or None, if we don't
            know what to do).
        """
        registry = getToolByName( self, 'content_type_registry' )
        if registry is None:
            return None

        typeObjectName = registry.findTypeName( name, typ, body )
        if typeObjectName is None:
            return None
        if typeObjectName == 'File':
            typeObjectName = 'DocMgtFile'
            
        self.invokeFactory( typeObjectName, name )
        

        # XXX: this is butt-ugly.
        obj = aq_base( self._getOb( name ) )
        self._delObject( name )
        return obj
          


registerType(DocMgtRoot)
